//
//  ENMessagePopover.h
//  ENPopover
//
//  Created by Andrew McGeachie on 1/3/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ENPopover.h"

extern NSString * const ENMessagePopoversShouldCloseNotification; // ENMessagePopover listens for this notification; sending it will cause all ENMessagePopovers to close

@class ENMessagePopoverViewController;


@interface ENMessagePopover : ENPopover {
  id mMessageText; // can be NSString or NSAttributedString
  NSImage * mImage;
  CGFloat mMaxWidth;
  CGFloat mMinWidth;
  BOOL mWraps;
  ENMessagePopoverViewController * mMessageViewController;
}

+ (ENMessagePopover*) displayPopoverWithString:(NSString*) aMessage andView:(NSView*) aView;

/**
 * Text to display in the popover
 */
@property (nonatomic, copy) id messageText; // always copy text to avoid mutation

/**
 * Attributed text to display in the popover
 */
- (void) setMessageAttributedText: (NSAttributedString *) messageText;


/**
 * Image to display in the popover (optional)
 */
@property (nonatomic, retain) NSImage * image;


/**
 * minimum width (optional)
 */
@property (nonatomic, assign) CGFloat maxWidth;


/**
 * maximum width (optional)
 */
@property (nonatomic, assign) CGFloat minWidth;


/**
 * want to word wrap (optional)
 */
@property (nonatomic, assign) BOOL wraps;


@end
