//
//  ENPopoverAware.h
//  ENPopover
//
//  Created by Andrew McGeachie on 1/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class ENPopover;


@protocol ENPopoverAware <NSObject>


/**
 * Register a popover.  Any previously registered popover will be closed.
 * If the popover's behavior is transient it should be closed if anything
 * interesting happens outside it.
 */
- (void) registerPopover: (ENPopover *) popover;


/**
 * Unregister a popover.  Nothing should/will be done with the popover by the receiver any longer.
 */
- (void) unregisterPopover: (ENPopover *) popover;


@end
