//
//  ENLocalizedStringHandler.h
//  ENSharedUtilities
//
//  Created by Zdzislaw Losvik on 22/01/2013.
//  Copyright (c) 2013 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface ENLocalizedStringHandler : NSObject
+ (NSString *)localizedStringForKey:(NSString *)key;
@end

/**
 * Convenience macro macro NSLocalizedStringFromTableInBundle to search in the ENSharedUtilities bundle
 */
#define ENSharedLocalizedString(key, comment)  \
  [ENLocalizedStringHandler localizedStringForKey:(key)]

/**
 * Redefine NSLocalizedString so it points to ENSharedLocalizedString. This makes sure that ENShareUtilities
 * always uses localized files from its bundle and not the main application's or helper's one.
 *
 * This header file must be included in the ENSharedUtilities precompiled header file just after the Cocoa Framework.
 */
#undef NSLocalizedString
#define NSLocalizedString(key, comment) ENSharedLocalizedString((key), (comment))

