//
//  ENDebug.h
//  EverNote
//
//  Created by Dirk Holtwick on 29.11.12.
//  Copyright (c) 2012 Evernote. All rights reserved.
//

#ifndef NO_LOG_4_COCOA
#import <Log4Cocoa/Log4Cocoa.h>
#endif

#if DEBUG
  #define ENAbortInDebugMode abort();
#else
  #define ENAbortInDebugMode
#endif

#define ENAssert(condition, fmt, ...) \
  do { \
    if (!(condition)) { \
      log4Error(@"%@ <%@:%d> %s\n\n    %s failed assertion\n\n%@", \
        (fmt ? [NSString stringWithFormat:fmt, ##__VA_ARGS__]: @""), \
        [[NSString stringWithUTF8String:__FILE__] lastPathComponent], \
        __LINE__, \
        __PRETTY_FUNCTION__, \
        #condition, \
        [NSThread callStackSymbols] \
      ); \
      ENAbortInDebugMode \
    } \
  } while(0)

#define ENAssert0(condition) ENAssert((condition), @"Assertion")

#define ENParameterAssert(condition) ENAssert((condition), @"Invalid parameter not satisfying: %s", #condition)
