//
//  ENScreenshotHelper.h
//  EverNote
//
//  Created by Brandon Volbright on 2/2/12.
//  Copyright (c) 2012 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <ENSharedUtilities/ENSelectorWindow.h>


typedef void (^ENScreenshotHelperImageCapturedBlock)(NSData *imageData);

@interface ENScreenshotHelper : NSObject <ENSelectorWindowDelegate> {
  ENScreenshotHelperImageCapturedBlock mBlock;
  ENSelectorWindow *mScreenshotWindowOverlay;
}

@property (readonly) BOOL isBusy;


/**
 * Capture an interactive screenshot (presenting crosshairs, letting user select either a rect
 * or a window). On success, call the given block with PNG image data.
 */
- (void)captureScreenshotAndCallBlock:(ENScreenshotHelperImageCapturedBlock)block;

/**
 * Capture non-interactive screenshot of the entire screen. On success, call the given block
 * with PNG image data.
 */
- (void)captureFullScreenshotAndCallBlock:(ENScreenshotHelperImageCapturedBlock)block;

/**
 * Cancel an interactive screenshot in progress.
 */
- (IBAction)cancelScreenshot:(id)sender;


@end
