//
//  ENPIToolbarItem.h
//  EverNote
//
//  Created by Zdzislaw Losvik on 26/03/2013.
//  Copyright (c) 2013 Evernote. All rights reserved.
//

#import <Foundation/Foundation.h>


/**
 * Evernote Plug-in Interface for Note Editor Toolbar Item
 */
@protocol ENPIToolbarItem <NSObject>

/**
 * Returns the icon to be displayed in the toolbar
 */
- (NSImage *)toolbarIcon;

/**
 * Returns the highlighted state of icon to be displayed in the toolbar
 */
- (NSImage *)toolbarIconHighlighted;

/**
 * Action sent when user clicks on the icon in the toolbar
 */
- (void)userDidClickToolbarItem;


@end
